Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Generators/CodeGenerator/RecursiveCodeGenerator.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Generators/CodeGenerator/RecursiveCodeGenerator.cs	(revision 15272)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Generators/CodeGenerator/RecursiveCodeGenerator.cs	(revision 15273)
@@ -49,8 +49,8 @@
     private static IEnumerable<Expression> RandomCodeWithSize(int points, IRandom random, IReadOnlyPushConfiguration pushConfiguration, IDictionary<string, Expression> customExpressions = null) {
       if (points == 1) {
-        return new[] { CodeGeneratorUtils.CreateExpressionOrErc(
+        return new[] { CodeGeneratorUtils.MapToExpression(
           random,
-          pushConfiguration.EnabledExpressions,
           pushConfiguration.ErcOptions,
+          pushConfiguration,
           customExpressions)
         };
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Individual/IndividualExtensions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Individual/IndividualExtensions.cs	(revision 15272)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Individual/IndividualExtensions.cs	(revision 15273)
@@ -6,43 +6,12 @@
   using HeuristicLab.Optimization;
   using HeuristicLab.Problems.ProgramSynthesis.Push.Configuration;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Data.Pool;
   using HeuristicLab.Problems.ProgramSynthesis.Push.Expressions;
   using HeuristicLab.Problems.ProgramSynthesis.Push.Generators.CodeGenerator;
-  using HeuristicLab.Random;
+  using HeuristicLab.Problems.ProgramSynthesis.Push.SolutionCreator;
 
   public static class IndividualExtensions {
-    public static PushProgram ToPushProgram(this Individual individual, IReadOnlyPushConfiguration config, ObjectPool<IRandom> randomPool) {
-      return individual.IntegerVector().ToPushProgram(config, randomPool);
-    }
-
-    public static PushProgram ToPushProgram(this Individual individual, IReadOnlyPushConfiguration config) {
-      return individual.IntegerVector().ToPushProgram(config);
-    }
 
     public static PushProgram ToPushProgram(this Individual individual, IReadOnlyPushConfiguration config, IRandom random) {
       return individual.IntegerVector().ToPushProgram(config, random);
-    }
-
-    public static PushProgram ToPushProgram(this IntegerVector vector, IReadOnlyPushConfiguration config, ObjectPool<IRandom> randomPool) {
-      var random = randomPool.Allocate();
-      var seed = vector.GetSeed();
-
-      random.Reset(seed);
-      var program = vector.ToPushProgram(config, random);
-      randomPool.Free(random);
-
-      return program;
-    }
-
-    public static PushProgram ToPushProgram(this IntegerVector vector, IReadOnlyPushConfiguration config) {
-      var seed = (uint)vector.GetSeed();
-      return vector.ToPushProgram(config, new MersenneTwister(seed));
-    }
-
-    public static int GetSeed(this IntegerVector vector) {
-      var seed = 17;
-      for (var i = 0; i < vector.Length; i++)
-        seed = seed * 23 + vector[i];
-      return seed;
     }
 
@@ -53,9 +22,18 @@
 
       for (var i = vector.Length - 1; i >= 0; i--) {
-        var expression = CodeGeneratorUtils.CreateExpressionOrErc(
-          vector[i],
+        var index = vector[i];
+
+        if (index == PushSolutionEncoding.End)
+          break;
+
+        // skip noops
+        if (index == PushSolutionEncoding.Noop)
+          continue;
+
+        var expression = CodeGeneratorUtils.MapToExpression(
+          index,
           random,
-          config.EnabledExpressions,
-          config.ErcOptions);
+          config.ErcOptions,
+          config);
 
         expressions.Add(expression);
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Individual/InduvidualMapper.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Individual/InduvidualMapper.cs	(revision 15272)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Individual/InduvidualMapper.cs	(revision 15273)
@@ -39,9 +39,9 @@
 
       for (; currentIndex < vector.Length; currentIndex++) {
-        var expression = CodeGeneratorUtils.CreateExpressionOrErc(
+        var expression = CodeGeneratorUtils.MapToExpression(
           vector[currentIndex] % config.EnabledExpressions.Count,
           random,
-          config.EnabledExpressions,
-          config.ErcOptions);
+          config.ErcOptions,
+          config);
 
         var expressionType = expression.GetType();
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Interpreter/Extensions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Interpreter/Extensions.cs	(revision 15272)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Interpreter/Extensions.cs	(revision 15273)
@@ -8,4 +8,6 @@
 
   using Attributes;
+
+  using HeuristicLab.BenchmarkSuite;
 
   using Stack;
@@ -60,4 +62,25 @@
       }
     }
+
+    public static void InitExample(this IPushInterpreter interpreter, Example example) {
+      interpreter.BooleanStack.Push(example.InputBoolean);
+      interpreter.IntegerStack.Push(example.InputInteger);
+      interpreter.FloatStack.Push(example.InputFloat);
+      interpreter.CharStack.Push(example.InputChar);
+      interpreter.StringStack.Push(example.InputString);
+      interpreter.StringVectorStack.Push(example.InputStringVector);
+      interpreter.IntegerVectorStack.Push(example.InputIntegerVector);
+      interpreter.FloatVectorStack.Push(example.InputFloatVector);
+
+      interpreter.SetInput(
+        integers: example.InputInteger,
+        floats: example.InputFloat,
+        booleans: example.InputBoolean,
+        chars: example.InputChar,
+        strings: example.InputString,
+        integerVectors: example.InputIntegerVector,
+        floatVectors: example.InputFloatVector,
+        stringVectors: example.InputStringVector);
+    }
   }
 }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Interpreter/IPushInterpreter.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Interpreter/IPushInterpreter.cs	(revision 15272)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Interpreter/IPushInterpreter.cs	(revision 15273)
@@ -11,5 +11,5 @@
 
   public interface IPushInterpreter {
-    IRandom Random { get; set; }
+    IRandom Random { get; }
     IPushStack<Expression> CodeStack { get; }
     IPushStack<Expression> ExecStack { get; }
@@ -28,6 +28,6 @@
     IReadOnlyDictionary<StackTypes, IPushStack> Stacks { get; }
     IReadOnlyPushConfiguration Configuration { get; }
-    void Clear();
-    void Reset();
+    void ClearStacks();
+    void Reset(IRandom random = null);
 
     void SetInput(
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Interpreter/PooledPushInterpreter.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Interpreter/PooledPushInterpreter.cs	(revision 15272)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Interpreter/PooledPushInterpreter.cs	(revision 15273)
@@ -15,5 +15,5 @@
     public override void Dispose() {
       base.Dispose();
-      Clear();
+      ClearStacks();
       pool.Free(this);
     }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Interpreter/PushInterpreter.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Interpreter/PushInterpreter.cs	(revision 15272)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Interpreter/PushInterpreter.cs	(revision 15273)
@@ -19,6 +19,13 @@
     private Expression currentProgram;
 
+    /// <summary>
+    /// An interpreter for Push
+    /// </summary>
+    /// <param name="config">Determines the runtime behavior of the interpreter</param>
+    /// <param name="random">Note that random may be reseted</param>
+    /// <param name="poolContainer">Used to save resources used by the interpreter</param>
     public PushInterpreter(IReadOnlyPushConfiguration config = null, IRandom random = null, InterpreterPoolContainer poolContainer = null) {
-      Random = random ?? new MersenneTwister();
+      randomOrigin = random ?? new MersenneTwister();
+      Random = (IRandom)randomOrigin.Clone();
       Configuration = config ?? new PushConfiguration();
 
@@ -69,5 +76,6 @@
     public IReadOnlyDictionary<StackTypes, IPushStack> Stacks { get; private set; }
 
-    public IRandom Random { get; set; }
+    private IRandom randomOrigin;
+    public IRandom Random { get; private set; }
 
     public long ExecCounter { get; private set; }
@@ -330,7 +338,13 @@
 
     /// <summary>
-    /// Reset while interpreter
+    /// Reset interpreter which clears and reconfigures stacks and local variables
     /// </summary>
-    public void Reset() {
+    public void Reset(IRandom random = null) {
+      if (random != null)
+        randomOrigin = random;
+
+      // Reset Random
+      Random = (IRandom)randomOrigin.Clone();
+
       ExecCounter = 0;
       IsAborted = false;
@@ -340,5 +354,5 @@
 
       inputExpressions.Clear();
-      Clear();
+      ClearStacks();
       ConfigureStacks();
     }
@@ -357,5 +371,5 @@
     /// Clears Stacks and custom expressions
     /// </summary>
-    public void Clear() {
+    public void ClearStacks() {
       for (var i = 0u; i < supportedStackTypes.Length; i++) {
         var key = supportedStackTypes[i];
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Interpreter/PushInterpreterPool.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Interpreter/PushInterpreterPool.cs	(revision 15272)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Interpreter/PushInterpreterPool.cs	(revision 15273)
@@ -5,5 +5,4 @@
   using HeuristicLab.Problems.ProgramSynthesis.Push.Data.Pool;
   using HeuristicLab.Problems.ProgramSynthesis.Push.Expressions;
-  using HeuristicLab.Random;
 
   public class PushInterpreterPool {
@@ -33,6 +32,5 @@
     public PooledPushInterpreter Create(IRandom random = null) {
       var interpreter = pool.Allocate();
-      interpreter.Random = random ?? new MersenneTwister();
-      interpreter.Reset();
+      interpreter.Reset(random);
 
       return interpreter;
@@ -40,5 +38,5 @@
 
     public void Free(PooledPushInterpreter interpreter) {
-      interpreter.Random = null;
+      interpreter.ClearStacks();
       pool.Free(interpreter);
     }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/ObjectPools/Random/SeededRandomPool.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/ObjectPools/Random/SeededRandomPool.cs	(revision 15273)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/ObjectPools/Random/SeededRandomPool.cs	(revision 15273)
@@ -0,0 +1,36 @@
+﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.ObjectPools.Random {
+  using System;
+
+  using HeuristicLab.Core;
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Data.Pool;
+  using HeuristicLab.Random;
+
+  public class SeededRandomPool {
+    public int Seed;
+    protected readonly ObjectPool<IRandom> Pool;
+
+    public SeededRandomPool() : this(new Random().Next()) { }
+
+    public SeededRandomPool(int seed) : this(seed, () => new MersenneTwister()) { }
+
+    public SeededRandomPool(int seed, Func<IRandom> randomCreator) {
+      Seed = seed;
+      Pool = new ObjectPool<IRandom>(randomCreator);
+    }
+
+    public IRandom ResetAndAllocate() {
+      var random = Pool.Allocate();
+      random.Reset(Seed);
+
+      return random;
+    }
+
+    public void Free(IRandom random) {
+      Pool.Free(random);
+    }
+
+    public void Clear() {
+      Pool.Clear();
+    }
+  }
+}
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/BenchmarkSuite/BenchmarkSuitePushSolutionView.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/BenchmarkSuite/BenchmarkSuitePushSolutionView.cs	(revision 15272)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/BenchmarkSuite/BenchmarkSuitePushSolutionView.cs	(revision 15273)
@@ -53,23 +53,5 @@
       var example = Evaluator.Data.Examples[exampleComboBox.SelectedIndex];
 
-      interpreter.SetInput(
-        integers: example.InputInteger,
-        floats: example.InputFloat,
-        booleans: example.InputBoolean,
-        chars: example.InputChar,
-        strings: example.InputString,
-        integerVectors: example.InputIntegerVector,
-        floatVectors: example.InputFloatVector,
-        stringVectors: example.InputStringVector);
-
-      //interpreter.BooleanStack.Push(example.InputBoolean);
-      //interpreter.IntegerStack.Push(example.InputInteger);
-      //interpreter.FloatStack.Push(example.InputFloat);
-      //interpreter.CharStack.Push(example.InputChar);
-      //interpreter.StringStack.Push(example.InputString);
-      //interpreter.IntegerVectorStack.Push(example.InputIntegerVector.Select(x => x.ToList()).ToList());
-      //interpreter.FloatVectorStack.Push(example.InputFloatVector.Select(x => x.ToList()).ToList());
-      //interpreter.StringVectorStack.Push(example.InputStringVector.Select(x => x.ToList()).ToList());
-      //interpreter.BooleanVectorStack.Push(example.InputBooleanVector.Select(x => x.ToList()).ToList());
+      interpreter.InitExample(example);
     }
 
@@ -92,4 +74,5 @@
     }
 
+
     protected override void OnContentChanged() {
       if (Content == null) return;
@@ -104,5 +87,6 @@
       }
 
-      interpreter = pool.Create(Content.Random);
+      var random = Content.GetRandom();
+      interpreter = pool.Create(random);
       UpdateExamples(Evaluator.Data);
 
@@ -181,5 +165,6 @@
       grid.Columns.Add(relativeDiffColumn);
 
-      using (var pushInterpreter = pool.Create(Content.Random)) {
+      var random = Content.GetRandom();
+      using (var pushInterpreter = pool.Create(random)) {
         var rowIndex = 1;
         for (var i = start; i < end; i++, rowIndex++) {
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/BenchmarkSuite/PushBenchmarkSuiteEvaluator.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/BenchmarkSuite/PushBenchmarkSuiteEvaluator.cs	(revision 15272)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/BenchmarkSuite/PushBenchmarkSuiteEvaluator.cs	(revision 15273)
@@ -131,23 +131,5 @@
       var example = Data.Examples[exampleIndex];
 
-      //interpreter.BooleanStack.Push(example.InputBoolean);
-      //interpreter.IntegerStack.Push(example.InputInteger);
-      //interpreter.FloatStack.Push(example.InputFloat);
-      //interpreter.CharStack.Push(example.InputChar);
-      //interpreter.StringStack.Push(example.InputString);
-      //interpreter.StringVectorStack.Push(example.InputStringVector);
-      //interpreter.IntegerVectorStack.Push(example.InputIntegerVector);
-      //interpreter.FloatVectorStack.Push(example.InputFloatVector);
-
-      interpreter.SetInput(
-        integers: example.InputInteger,
-        floats: example.InputFloat,
-        booleans: example.InputBoolean,
-        chars: example.InputChar,
-        strings: example.InputString,
-        integerVectors: example.InputIntegerVector,
-        floatVectors: example.InputFloatVector,
-        stringVectors: example.InputStringVector);
-
+      interpreter.InitExample(example);
       interpreter.Run(program);
 
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/BenchmarkSuite/PushBenchmarkSuiteProblem.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/BenchmarkSuite/PushBenchmarkSuiteProblem.cs	(revision 15272)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/BenchmarkSuite/PushBenchmarkSuiteProblem.cs	(revision 15273)
@@ -8,5 +8,4 @@
   using HeuristicLab.BenchmarkSuite.Problems;
   using HeuristicLab.Problems.ProgramSynthesis.Push.Expressions;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Extensions;
 
   using Instances;
@@ -49,16 +48,16 @@
       Description = data.Description;
       BestKnownQuality = data.BestResult;
-      config.MaxPointsInProgram = data.MaxSize;
-      config.EvalPushLimit = data.EvalLimit;
-      config.ErcOptions = data.ErcOptions;
-      config.FloatStringFormat = data.FloatStringFormat;
+      Config.MaxPointsInProgram = data.MaxSize;
+      Config.EvalPushLimit = data.EvalLimit;
+      Config.ErcOptions = data.ErcOptions;
+      Config.FloatStringFormat = data.FloatStringFormat;
 
-      config.SetEnabledStacks((StackTypes)data.EnabledDataTypes);
-      data.InitInExpressions(config);
+      Config.SetEnabledStacks((StackTypes)data.EnabledDataTypes);
+      Config.InitInExpressions(data.TotalInputArgumentCount);
 
       Encoding.Bounds[0, 0] = 0;
-      Encoding.Bounds[0, 1] = config.EnabledExpressions.Count;
+      Encoding.Bounds[0, 1] = Config.EnabledExpressions.Count;
 
-      InitProgramLength = data.MaxSize / 2;
+      Encoding.Length = data.MaxSize;
     }
 
@@ -67,7 +66,6 @@
       double bestQuality,
       IRandom random,
-      IReadOnlyPushConfiguration config,
-      IPushEvaluator evaluator) {
-      return new PushBenchmarkSuiteSolution(program, bestQuality, random, (IReadOnlyPushConfiguration)config.Clone(), (PushBenchmarkSuiteEvaluator)PushEvaluator.Clone());
+      IReadOnlyPushConfiguration config) {
+      return new PushBenchmarkSuiteSolution(program, bestQuality, random, config, (PushBenchmarkSuiteEvaluator)PushEvaluator.Clone());
     }
   }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/PushProblem.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/PushProblem.cs	(revision 15272)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/PushProblem.cs	(revision 15273)
@@ -7,5 +7,4 @@
   using Configuration;
   using Core;
-  using Data.Pool;
   using HeuristicLab.Data;
   using HeuristicLab.Encodings.IntegerVectorEncoding;
@@ -13,5 +12,6 @@
   using HeuristicLab.Problems.ProgramSynthesis.Push.Expressions;
   using HeuristicLab.Problems.ProgramSynthesis.Push.Individual;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Problem.BenchmarkSuite;
+  using HeuristicLab.Problems.ProgramSynthesis.Push.ObjectPools.Random;
+  using HeuristicLab.Problems.ProgramSynthesis.Push.SolutionCreator;
 
   using Interpreter;
@@ -19,21 +19,21 @@
   using Parameters;
   using Persistence.Default.CompositeSerializers.Storable;
-  using Random;
 
   [StorableClass]
   public abstract class PushProblem : SingleObjectiveBasicProblem<IntegerVectorEncoding> {
     [Storable]
-    protected readonly PushConfigurationParameterCollection config;
-    protected PushInterpreterPool pool;
-    protected readonly ObjectPool<IRandom> randomPool = new ObjectPool<IRandom>(() => new MersenneTwister(), Environment.ProcessorCount * 4);
+    protected readonly PushConfigurationParameterCollection Config;
+
+    protected PushInterpreterPool Pool;
+    protected readonly SeededRandomPool RandomPool = new SeededRandomPool();
 
     [Storable]
     protected readonly IPushEvaluator PushEvaluator;
 
-    private const string BestTrainingSolutionResultName = "Best Solution";
-    private const string TestQualityResultName = "Test Quality";
-
-    protected PushProblem(PushBenchmarkSuiteEvaluator evaluator) {
-      config = new PushConfigurationParameterCollection();
+    private const string BEST_TRAINING_SOLUTION_RESULT_NAME = "Best Solution";
+    private const string TEST_QUALITY_RESULT_NAME = "Test Quality";
+
+    protected PushProblem(IPushEvaluator evaluator) {
+      Config = new PushConfigurationParameterCollection();
       PushEvaluator = evaluator;
 
@@ -52,5 +52,5 @@
     protected PushProblem(PushProblem original, Cloner cloner)
       : base(original, cloner) {
-      config = cloner.Clone(original.config);
+      Config = cloner.Clone(original.Config);
       PushEvaluator = cloner.Clone(original.PushEvaluator);
 
@@ -68,25 +68,18 @@
 
     private void InitData() {
-      pool = new PushInterpreterPool(Environment.ProcessorCount * 2, 4096, 1024, config);
+      Pool = new PushInterpreterPool(Environment.ProcessorCount * 2, 4096, 1024, Config);
     }
 
     private void InitEvents() {
-      config.EnabledExpressionsChanged += EnabledExpressionsChanged;
+      Config.EnabledExpressionsChanged += EnabledExpressionsChanged;
+      Reset += PushProblemReset;
     }
 
     private void EnabledExpressionsChanged(object sender, EnabledExpressionsChangedEventArgs e) {
-      Encoding.Bounds[0, 1] = config.EnabledExpressions.Count;
-      Encoding.BoundsParameter.Value[0, 1] = config.EnabledExpressions.Count;
-    }
-
-    public ILookupParameter<IntValue> SeedParamater
-    {
-      get { return (ILookupParameter<IntValue>)Parameters["Seed"]; }
-    }
-
-    #region Parameters
-    private const string InitProgramLengthParameterName = "InitProgramLength";
-    private const string InitProgramLengthParameterDescription = "This is the initial size of a push program.";
-    private const string PushConfigurationParameterName = "PushConfiguration";
+      Encoding.Bounds[0, 1] = Config.EnabledExpressions.Count;
+      Encoding.BoundsParameter.Value[0, 1] = Config.EnabledExpressions.Count;
+    }
+
+    private const string PUSH_CONFIGURATION_PARAMETER_NAME = "PushConfiguration";
 
     public const string CasesScopeParameterName = "CaseQualities";
@@ -94,5 +87,5 @@
 
     private void InitParameters() {
-      foreach (var paramater in config.Parameters) {
+      foreach (var paramater in Config.Parameters) {
         if (!Parameters.ContainsKey(paramater.Name)) {
           Parameters.Add(paramater);
@@ -100,18 +93,9 @@
       }
 
-      if (!Parameters.ContainsKey(PushConfigurationParameterName))
-        Parameters.Add(new ValueParameter<IReadOnlyPushConfiguration>(PushConfigurationParameterName, config) {
+      if (!Parameters.ContainsKey(PUSH_CONFIGURATION_PARAMETER_NAME))
+        Parameters.Add(new ValueParameter<IReadOnlyPushConfiguration>(PUSH_CONFIGURATION_PARAMETER_NAME, Config) {
           Hidden = true
         });
 
-      if (!Parameters.ContainsKey(InitProgramLengthParameterName)) {
-        Parameters.Add(new FixedValueParameter<IntValue>(
-          InitProgramLengthParameterName,
-          InitProgramLengthParameterDescription,
-          new IntValue(50)));
-      }
-
-      Encoding.LengthParameter = InitProgramLengthParameter as IFixedValueParameter<IntValue>;
-
       if (!Parameters.ContainsKey(CasesScopeParameterName))
         Parameters.Add(new LookupParameter<BoolArray>(CasesScopeParameterName, "The training cases that have been successfully executed."));
@@ -121,39 +105,47 @@
     }
 
+    private void PushProblemReset(object sender, EventArgs e) {
+      // clear pools and free reserved memory
+      Pool.Clear();
+      IndividualMapper.Clear();
+      RandomPool.Clear();
+
+      // reset seed
+      Config.Seed = 0;
+    }
+
     protected override void OnReset() {
       base.OnReset();
 
       // clear pools and free reserved memory
-      pool.Clear();
+      Pool.Clear();
       IndividualMapper.Clear();
+      RandomPool.Clear();
+      Config.Seed = 0;
     }
 
     private void InitEncoding() {
       Encoding.Bounds[0, 0] = 0;
-      Encoding.Bounds[0, 1] = config.EnabledExpressions.Count;
-      Encoding.Length = config.MaxPointsInProgram;
+      Encoding.Bounds[0, 1] = Config.EnabledExpressions.Count;
+      Encoding.Length = Config.MaxPointsInProgram;
     }
 
     private void InitOperators() {
-      Operators.Add(new PushExpressionFrequencyAnalyzer());
-    }
-
-    /// <summary>
-    ///     This is the inital size of an push program generated by a solution creator
-    /// </summary>
-    public IValueParameter<IntValue> InitProgramLengthParameter
-    {
-      get { return (IValueParameter<IntValue>)Parameters[InitProgramLengthParameterName]; }
-    }
-
-    public int InitProgramLength
-    {
-      get { return InitProgramLengthParameter.Value.Value; }
-      set
-      {
-        InitProgramLengthParameter.Value.Value = value;
-      }
-    }
-    #endregion
+
+      var solutionCreator = Operators.OfType<PushSolutionCreator>().FirstOrDefault();
+
+      if (solutionCreator == null) {
+        solutionCreator = new PushSolutionCreator();
+        Operators.Add(solutionCreator);
+      }
+
+      solutionCreator.ErcOptions = Config.ErcOptions;
+
+      if (!Operators.OfType<PushExpressionFrequencyAnalyzer>().Any()) {
+        Operators.Add(new PushExpressionFrequencyAnalyzer());
+      }
+
+      SolutionCreator = solutionCreator;
+    }
 
     public override bool Maximization { get { return false; } }
@@ -165,68 +157,55 @@
       var bestIdx = Array.IndexOf(qualities, bestQuality);
       var vector = individuals[bestIdx].IntegerVector();
-      var seed = vector.GetSeed();
-      var rand = randomPool.Allocate();
-      rand.Reset(seed);
-
-      var program = (PushProgram)vector.ToPushProgram(config, rand).Clone();
+
+      var rand = RandomPool.ResetAndAllocate();
+      var program = (PushProgram)vector.ToPushProgram(Config, rand).Clone();
+      RandomPool.Free(rand);
+
+      rand = RandomPool.ResetAndAllocate();
       var isIndividualBetter = AnalyzeBestTrainingSolution(program, bestQuality, results, rand);
+      RandomPool.Free(rand);
 
       if (isIndividualBetter) {
-        rand.Reset(seed);
+        rand = RandomPool.ResetAndAllocate();
         AnalyzeBestTestSolution(program, results, rand);
-      }
-
-      randomPool.Free(rand);
+        RandomPool.Free(rand);
+      }
     }
 
     private void AnalyzeBestTestSolution(PushProgram program, ResultCollection results, IRandom random) {
-      var testResult = PushEvaluator.EvaluateTraining(pool, program, random);
-
-      if (!results.ContainsKey(TestQualityResultName)) {
-        results.Add(new Result(TestQualityResultName, new DoubleValue(testResult.AvgQuality)));
+      var testResult = PushEvaluator.EvaluateTraining(Pool, program, random);
+
+      if (!results.ContainsKey(TEST_QUALITY_RESULT_NAME)) {
+        results.Add(new Result(TEST_QUALITY_RESULT_NAME, new DoubleValue(testResult.AvgQuality)));
       } else {
-        ((DoubleValue)results[TestQualityResultName].Value).Value = testResult.AvgQuality;
+        ((DoubleValue)results[TEST_QUALITY_RESULT_NAME].Value).Value = testResult.AvgQuality;
       }
     }
 
     private bool AnalyzeBestTrainingSolution(PushProgram program, double bestQuality, ResultCollection results, IRandom random) {
-      if (!results.ContainsKey(BestTrainingSolutionResultName)) {
+      if (!results.ContainsKey(BEST_TRAINING_SOLUTION_RESULT_NAME)) {
         var solution = CreatePushSolution(
             program,
             bestQuality,
-            random,
-            config,
-            PushEvaluator);
-
-        results.Add(new Result(BestTrainingSolutionResultName, solution));
+            (IRandom)random.Clone(),
+            (IReadOnlyPushConfiguration)Config.Clone());
+
+        results.Add(new Result(BEST_TRAINING_SOLUTION_RESULT_NAME, solution));
         return true;
       }
 
-      var currentBestQuality = ((PushSolution)results[BestTrainingSolutionResultName].Value).Quality;
+      var currentBestQuality = ((PushSolution)results[BEST_TRAINING_SOLUTION_RESULT_NAME].Value).Quality;
 
       if ((!Maximization && currentBestQuality > bestQuality) ||
            (Maximization && currentBestQuality < bestQuality)) {
-        results[BestTrainingSolutionResultName].Value = CreatePushSolution(
+        results[BEST_TRAINING_SOLUTION_RESULT_NAME].Value = CreatePushSolution(
             program,
             bestQuality,
             random,
-            config,
-            PushEvaluator);
+            Config);
         return true;
       }
 
       return false;
-    }
-
-    private EvaluationResult EvaluateIntegerVector(IntegerVector vector) {
-      var rand = randomPool.Allocate();
-      var seed = vector.GetSeed();
-      rand.Reset(seed);
-
-      var program = vector.ToPushProgram(config, rand);
-      var result = PushEvaluator.EvaluateTraining(pool, program, rand);
-      randomPool.Free(rand);
-
-      return result;
     }
 
@@ -235,10 +214,18 @@
       double bestQuality,
       IRandom random,
-      IReadOnlyPushConfiguration config,
-      IPushEvaluator evaluator);
+      IReadOnlyPushConfiguration config);
 
     public override double Evaluate(Individual individual, IRandom random) {
-      var vector = individual.IntegerVector();
-      var result = EvaluateIntegerVector(vector);
+      // init seed of random pool
+      //Interlocked.CompareExchange(ref RandomPool.Seed, random.Next(), 0);
+      //Config.Seed = RandomPool.Seed;
+
+      //var rand = RandomPool.ResetAndAllocate();
+      var program = individual.ToPushProgram(Config, random);
+      //RandomPool.Free(rand);
+
+      //rand = RandomPool.ResetAndAllocate();
+      var result = PushEvaluator.EvaluateTraining(Pool, program, random);
+      //RandomPool.Free(rand);
 
       individual[CaseQualitiesScopeParameterName] = new DoubleArray(result.ExampleQualities);
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/PushSolution.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/PushSolution.cs	(revision 15272)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/PushSolution.cs	(revision 15273)
@@ -11,5 +11,5 @@
     public readonly double Quality;
     [Storable]
-    public readonly IRandom Random;
+    protected readonly IRandom Random;
     [Storable]
     public readonly IReadOnlyPushConfiguration Config;
@@ -46,4 +46,8 @@
     }
 
+    public IRandom GetRandom() {
+      return (IRandom)Random.Clone();
+    }
+
     public virtual PushSolution Simplify() {
       return new PushSolution(Program, Quality, Random, Config, Evaluator, true);
